import java.util.*;

public class Sample {
  public static void main(String[] args) {
    List<Integer> numbers = List.of(1, 2, 3);

    System.out.println(numbers);
    System.out.println(numbers.getClass());

    //Set.of
    System.out.println(Map.of("a", 1, "b", 2));

    //of method create immutable collections.

    //copyOf will make a copy that is immutable.
    //If the source is immutable, then the copyOf merely returns
    //the reference to you - save the overhead of copying.
    //immutable objects can be shared safely.

    var result = List.copyOf(numbers);
    System.out.println(result == numbers);
  }
}
